"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchFanoutMintFromSeeds = exports.fetchFanoutMintFromSeeds = exports.findFanoutMintPda = exports.getFanoutMintSize = exports.getFanoutMintGpaBuilder = exports.safeFetchAllFanoutMint = exports.fetchAllFanoutMint = exports.safeFetchFanoutMint = exports.fetchFanoutMint = exports.deserializeFanoutMint = exports.getFanoutMintAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getFanoutMintAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['mint', s.publicKey()],
        ['fanout', s.publicKey()],
        ['tokenAccount', s.publicKey()],
        ['totalInflow', s.u64()],
        ['lastSnapshotAmount', s.u64()],
        ['bumpSeed', s.u8()],
    ], { description: 'FanoutMintAccountData' }), (value) => ({
        ...value,
        discriminator: [50, 164, 42, 108, 90, 201, 250, 216],
    }));
}
exports.getFanoutMintAccountDataSerializer = getFanoutMintAccountDataSerializer;
function deserializeFanoutMint(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getFanoutMintAccountDataSerializer(context));
}
exports.deserializeFanoutMint = deserializeFanoutMint;
async function fetchFanoutMint(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'FanoutMint');
    return deserializeFanoutMint(context, maybeAccount);
}
exports.fetchFanoutMint = fetchFanoutMint;
async function safeFetchFanoutMint(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeFanoutMint(context, maybeAccount)
        : null;
}
exports.safeFetchFanoutMint = safeFetchFanoutMint;
async function fetchAllFanoutMint(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'FanoutMint');
        return deserializeFanoutMint(context, maybeAccount);
    });
}
exports.fetchAllFanoutMint = fetchAllFanoutMint;
async function safeFetchAllFanoutMint(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeFanoutMint(context, maybeAccount));
}
exports.safeFetchAllFanoutMint = safeFetchAllFanoutMint;
function getFanoutMintGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplHydra', 'hyDQ4Nz1eYyegS6JfenyKwKzYxRsCWCriYSAjtzP4Vg');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        discriminator: [0, s.array(s.u8(), { size: 8 })],
        mint: [8, s.publicKey()],
        fanout: [40, s.publicKey()],
        tokenAccount: [72, s.publicKey()],
        totalInflow: [104, s.u64()],
        lastSnapshotAmount: [112, s.u64()],
        bumpSeed: [120, s.u8()],
    })
        .deserializeUsing((account) => deserializeFanoutMint(context, account))
        .whereField('discriminator', [50, 164, 42, 108, 90, 201, 250, 216]);
}
exports.getFanoutMintGpaBuilder = getFanoutMintGpaBuilder;
function getFanoutMintSize() {
    return 200;
}
exports.getFanoutMintSize = getFanoutMintSize;
function findFanoutMintPda(context, seeds) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplHydra', 'hyDQ4Nz1eYyegS6JfenyKwKzYxRsCWCriYSAjtzP4Vg');
    return context.eddsa.findPda(programId, [
        s.string({ size: 'variable' }).serialize('fanout-config'),
        s.publicKey().serialize(seeds.fanout),
        s.publicKey().serialize(seeds.mint),
    ]);
}
exports.findFanoutMintPda = findFanoutMintPda;
async function fetchFanoutMintFromSeeds(context, seeds, options) {
    return fetchFanoutMint(context, findFanoutMintPda(context, seeds), options);
}
exports.fetchFanoutMintFromSeeds = fetchFanoutMintFromSeeds;
async function safeFetchFanoutMintFromSeeds(context, seeds, options) {
    return safeFetchFanoutMint(context, findFanoutMintPda(context, seeds), options);
}
exports.safeFetchFanoutMintFromSeeds = safeFetchFanoutMintFromSeeds;
//# sourceMappingURL=fanoutMint.js.map