"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.distributeToken = exports.getDistributeTokenInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const shared_1 = require("../shared");
function getDistributeTokenInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['distributeForMint', s.bool()],
    ], { description: 'DistributeTokenInstructionData' }), (value) => ({
        ...value,
        discriminator: [126, 105, 46, 135, 28, 36, 117, 212],
    }));
}
exports.getDistributeTokenInstructionDataSerializer = getDistributeTokenInstructionDataSerializer;
// Instruction.
function distributeToken(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplHydra', 'hyDQ4Nz1eYyegS6JfenyKwKzYxRsCWCriYSAjtzP4Vg'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'rent', input.rent ?? (0, umi_1.publicKey)('SysvarRent111111111111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenProgram', input.tokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, false),
    });
    // Member.
    keys.push({
        pubkey: resolvedAccounts.member,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.member, true),
    });
    // Membership Mint Token Account.
    keys.push({
        pubkey: resolvedAccounts.membershipMintTokenAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.membershipMintTokenAccount, true),
    });
    // Membership Voucher.
    keys.push({
        pubkey: resolvedAccounts.membershipVoucher,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.membershipVoucher, true),
    });
    // Fanout.
    keys.push({
        pubkey: resolvedAccounts.fanout,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.fanout, true),
    });
    // Holding Account.
    keys.push({
        pubkey: resolvedAccounts.holdingAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.holdingAccount, true),
    });
    // Fanout For Mint.
    keys.push({
        pubkey: resolvedAccounts.fanoutForMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.fanoutForMint, true),
    });
    // Fanout For Mint Membership Voucher.
    keys.push({
        pubkey: resolvedAccounts.fanoutForMintMembershipVoucher,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.fanoutForMintMembershipVoucher, true),
    });
    // Fanout Mint.
    keys.push({
        pubkey: resolvedAccounts.fanoutMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.fanoutMint, false),
    });
    // Fanout Mint Member Token Account.
    keys.push({
        pubkey: resolvedAccounts.fanoutMintMemberTokenAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.fanoutMintMemberTokenAccount, true),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Rent.
    keys.push({
        pubkey: resolvedAccounts.rent,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.rent, false),
    });
    // Token Program.
    keys.push({
        pubkey: resolvedAccounts.tokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenProgram, false),
    });
    // Membership Mint.
    keys.push({
        pubkey: resolvedAccounts.membershipMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.membershipMint, true),
    });
    // Member Stake Account.
    keys.push({
        pubkey: resolvedAccounts.memberStakeAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.memberStakeAccount, true),
    });
    // Data.
    const data = getDistributeTokenInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.distributeToken = distributeToken;
//# sourceMappingURL=distributeToken.js.map